package spads1;

// Class created by Simon Dellicour (February 2013)

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;

public class SuStsComparison 
{
	public ArrayList<String> summaryStats;
	public ArrayList<String> allSummaryStats;
	public ArrayList<String> simDatasetsNames;
	public ArrayList<String> obsDatasetsNames;
	public ArrayList<String> externalMessage;
	
	public SuStsComparison() throws IOException
		{
			externalMessage = new ArrayList<String>();
			
			ArrayList<String> lines1 = new ArrayList<String>();				
			String name1 = "summary_stats_comparison.txt";
			BufferedReader in1 = new BufferedReader(new FileReader(name1));
			String s1;
			ArrayList<String> lines10 = new ArrayList<String>();
			while((s1 = in1.readLine()) != null) lines10.add(s1);
			lines1 = lines10;
			in1.close();
			
			String line11a = (String) lines1.get(0);
			String[] line11b = line11a.split("[ 	]+");
			summaryStats = new ArrayList<String>();
			for (int i = 0; i < line11b.length; i++)
				{
					summaryStats.add(line11b[i]);
					// System.out.println(summaryStats.get(i));
				}
			
			obsDatasetsNames = new ArrayList<String>();
			simDatasetsNames = new ArrayList<String>();
			for (int i = 1; i < lines1.size(); i++)
				{
					String line12a = (String) lines1.get(i);
					String[] line12b = line12a.split("[ 	]+");
					obsDatasetsNames.add(line12b[0]);
					// System.out.println(obsDatasetsNames.get(i-1));
					simDatasetsNames.add(line12b[1]);
					// System.out.println(simDatasetsNames.get(i-1));
				}
			
			String firstLine = new String();
			firstLine = "P-values associated with the comparison between observed and simulated datasets:";
			externalMessage.add(firstLine);
			String secondLine = new String();
			secondLine = "	(selected summary statistics:";
			for (int i = 0; i < summaryStats.size(); i++)
				{
					secondLine = secondLine + " " + summaryStats.get(i);
				}
			secondLine = secondLine + ")";
			externalMessage.add(secondLine);
			
			for (int i = 0; i < obsDatasetsNames.size(); i++)
				{
					/* if (obsDatasetsNames.get(i).equals(simDatasetsNames.get(i)))
						{
							this.bootstraps(obsDatasetsNames.get(i), simDatasetsNames.get(i));
						}
					else
						{ */
							this.simpleComparison(obsDatasetsNames.get(i), simDatasetsNames.get(i));
						// }
				}
		}
	
	/* private void bootstraps(String obsDatasetsNames, String simDatasetsNames) throws IOException
		{
			String thirdLine = new String();
			thirdLine = "";
			externalMessage.add(thirdLine);
			String fourthLine = new String();
			fourthLine = obsDatasetsNames + " - " + simDatasetsNames + ", boostraps p-values:";
			externalMessage.add(fourthLine);
			
			// To determine the number of simulations:
			int numberOfSimulations = 0;
			ArrayList<String> lines4 = new ArrayList<String>();
			String name4 = simDatasetsNames + ".txt";
			BufferedReader in4 = new BufferedReader(new FileReader(name4));
			String s4;
			ArrayList<String> lines40 = new ArrayList<String>();
			while((s4 = in4.readLine()) != null) lines40.add(s4);
			lines4 = lines40;
			in4.close();
			for (int j = 1; j < lines4.size(); j ++)
				{
					if (lines4.get(j).isEmpty())
						{ }
					else
						{
							numberOfSimulations = numberOfSimulations + 1;
						}
				}
			
			ArrayList<String> lines2 = new ArrayList<String>();
			String name2 = obsDatasetsNames + ".txt";
			BufferedReader in2 = new BufferedReader(new FileReader(name2));
			String s2;
			ArrayList<String> lines20 = new ArrayList<String>();
			while((s2 = in2.readLine()) != null) lines20.add(s2);
			lines2 = lines20;
			in2.close();			
			allSummaryStats = new ArrayList<String>();
			String line21a = (String) lines2.get(0);
			String[] line21b = line21a.split("[ 	]+");
			for (int j = 0; j < line21b.length; j++)
				{
					allSummaryStats.add(line21b[j]);
				}
		
			int[] statsIndexes = new int[summaryStats.size()];
			// this vector will contain the indexes of selected summary statistics
			int counter = 0;
			for (int j = 0; j < allSummaryStats.size(); j++)
				{
					for (int k = 0; k < summaryStats.size(); k++)
						{
							if (allSummaryStats.get(j).equals(summaryStats.get(k)))
								{
									statsIndexes[counter] = j;
									counter = counter + 1;
								}
						}
				}
			
			for (int h = 0; h < numberOfSimulations; h++)
				{
					ArrayList<Double> obsSummaryStats = new ArrayList<Double>();
					String line22a = (String) lines2.get(h+1);
					String[] line22b = line22a.split("[ 	]+");
					for (int j = 0; j < line22b.length; j++)
						{
							Double stat = new Double(line22b[j]);
							obsSummaryStats.add(stat);
						}
				
					ArrayList<String> lines3 = new ArrayList<String>();
					String name3 = simDatasetsNames + ".txt";
					BufferedReader in3 = new BufferedReader(new FileReader(name3));
					String s3;
					ArrayList<String> lines30 = new ArrayList<String>();
					while((s3 = in3.readLine()) != null) lines30.add(s3);
					lines3 = lines30;
					in3.close();
					ArrayList<ArrayList<Double>> simSummaryStats = new ArrayList<ArrayList<Double>>();
					for (int j = 1; j < lines3.size(); j ++)
						{
							if (lines3.get(j).isEmpty())
								{ }
							else if ((j) == (h+1))
								// to remove the current analysed simulation
								{ 
									// System.out.println(h+1);
								}
							else
								{
									ArrayList<Double> simSummaryStatsLine = new ArrayList<Double>();
									String line0 = (String) lines3.get(j);
									String[] line = line0.split("[ 	]+");
									for (int k = 0; k < line.length; k++)
										{
											Double stat = new Double(line[k]);
											simSummaryStatsLine.add(stat);
										}
									simSummaryStats.add(simSummaryStatsLine);
								}
						}
					
					// Average summary stats computation:
					ArrayList<Double> averageSummaryStats = new ArrayList<Double>();
					for (int j = 0; j < summaryStats.size(); j++)
						{
							double average = 0;
							// System.out.println(simSummaryStats.size() + " - " + statsIndexes[0] + " - " + statsIndexes[1] + " - " + statsIndexes[2]);
							for (int k = 0; k < simSummaryStats.size(); k++)
								{
									average = average + simSummaryStats.get(k).get(statsIndexes[j]).doubleValue();
								}
							average = average/simSummaryStats.size();
							// System.out.println(average);
							Double averageDouble = new Double(average);
							averageSummaryStats.add(averageDouble);
						}
					
					// Average summary stats computation:
					ArrayList<Double> standardDeviationSummaryStats = new ArrayList<Double>();
					for (int j = 0; j < summaryStats.size(); j++)
						{
							double deviationStandard = 0;
							for (int k = 0; k < simSummaryStats.size(); k++)
								{
									double product = 0;
									// System.out.println(statsIndexes[j]);
									product = averageSummaryStats.get(j).doubleValue() - simSummaryStats.get(k).get(statsIndexes[j]).doubleValue();
									product = product*product;
									deviationStandard = deviationStandard + product;
								}
							deviationStandard = deviationStandard/(simSummaryStats.size() - 1);
							deviationStandard = Math.sqrt(deviationStandard);
							// System.out.println(deviationStandard);
							Double deviationStandardDouble = new Double(deviationStandard);
							standardDeviationSummaryStats.add(deviationStandardDouble);
						}
					
					// Observed Chi-square computation:
					double obsChiSquare = 0;
					for (int j = 0; j < statsIndexes.length; j++)
						{
							double chiSquare = 0;
							chiSquare = (averageSummaryStats.get(j)-obsSummaryStats.get(statsIndexes[j]))*(averageSummaryStats.get(j)-obsSummaryStats.get(statsIndexes[j]));
							chiSquare = chiSquare/(standardDeviationSummaryStats.get(j)*standardDeviationSummaryStats.get(j));
							obsChiSquare = obsChiSquare + chiSquare;
						}
					
					// Simulated Chi-square's computation:
					ArrayList<Double> simChiSquares = new ArrayList<Double>();
					for (int j = 0; j < simSummaryStats.size(); j++)
						{
							double simChiSquare = 0;
							for (int k = 0; k < statsIndexes.length; k++)
								{
									double chiSquare = 0;
									chiSquare = (averageSummaryStats.get(k)-simSummaryStats.get(j).get(statsIndexes[k]))*(averageSummaryStats.get(k)-simSummaryStats.get(j).get(statsIndexes[k]));
									chiSquare = chiSquare/(standardDeviationSummaryStats.get(k)*standardDeviationSummaryStats.get(k));
									simChiSquare = simChiSquare + chiSquare;
								}
							Double simChiSquareDouble = new Double(simChiSquare);
							simChiSquares.add(simChiSquareDouble);
						}
					
					// P-value computation:
					int chiSquareCounter = 0;
					for (int j = 0; j < simSummaryStats.size(); j++)
						{
							// System.out.println(obsChiSquare + " - " + simChiSquares.get(j).doubleValue());
							if (simChiSquares.get(j).doubleValue() < obsChiSquare)
								{
									chiSquareCounter = chiSquareCounter + 1;
								}
							// System.out.println(chiSquareCounter);
						}
					double size = simSummaryStats.size();
					double pValue = ((simSummaryStats.size()-chiSquareCounter)/size);
					String currentLine = new String();
					currentLine = "Bootstrap p-value for simulation " + (h+1) + " =	" + (float) pValue;
					externalMessage.add(currentLine);
				}	
		} */
	
	private void simpleComparison(String obsDatasetsNames, String simDatasetsNames) throws IOException
		{
			ArrayList<String> lines2 = new ArrayList<String>();
			String name2 = obsDatasetsNames + ".txt";
			BufferedReader in2 = new BufferedReader(new FileReader(name2));
			String s2;
			ArrayList<String> lines20 = new ArrayList<String>();
			while((s2 = in2.readLine()) != null) lines20.add(s2);
			lines2 = lines20;
			in2.close();			
			allSummaryStats = new ArrayList<String>();
			String line21a = (String) lines2.get(0);
			String[] line21b = line21a.split("[ 	]+");
			for (int i = 0; i < line21b.length; i++)
				{
					allSummaryStats.add(line21b[i]);
				}
			int[] statsIndexes = new int[summaryStats.size()];
			// this vector will contain the indexes of selected summary statistics
			int counter = 0;
			for (int i = 0; i < allSummaryStats.size(); i++)
				{
					for (int k = 0; k < summaryStats.size(); k++)
						{
							if (allSummaryStats.get(i).equals(summaryStats.get(k)))
								{
									// System.out.println(allSummaryStats.get(i) + " - " + summaryStats.get(k));
									statsIndexes[counter] = (i); // System.out.println(i);
									counter = counter + 1;
								}
						}
				}
			ArrayList<Double> obsSummaryStats = new ArrayList<Double>();
			
			// System.out.println(lines2.size());
			boolean onlyOneObservedDataset = false;
			if (lines2.size() < 3)
				{
					onlyOneObservedDataset = true;
				}
			else if (lines2.get(2).isEmpty())
				{
					onlyOneObservedDataset = true;
				}
			
			if (onlyOneObservedDataset)
				{
					String line22a = (String) lines2.get(1);
					obsSummaryStats = new ArrayList<Double>();
					String[] line22b = line22a.split("[ 	]+");
					for (int j = 0; j < line22b.length; j++)
						{
							Double stat = new Double(line22b[j]);
							obsSummaryStats.add(stat);
							// System.out.println(obsSummaryStats.get(j));
						}
					
					ArrayList<String> lines3 = new ArrayList<String>();
					String name3 = simDatasetsNames + ".txt";
					BufferedReader in3 = new BufferedReader(new FileReader(name3));
					String s3;
					ArrayList<String> lines30 = new ArrayList<String>();
					while((s3 = in3.readLine()) != null) lines30.add(s3);
					lines3 = lines30;
					in3.close();
					ArrayList<ArrayList<Double>> simSummaryStats = new ArrayList<ArrayList<Double>>();
					for (int j = 1; j < lines3.size(); j ++)
						{
							ArrayList<Double> simSummaryStatsLine = new ArrayList<Double>();
							if (lines3.get(j).isEmpty())
								{ }
							else
								{
									String line0 = (String) lines3.get(j);
									String[] line = line0.split("[ 	]+");
									for (int k = 0; k < line.length; k++)
										{
											Double stat = new Double(line[k]);
											simSummaryStatsLine.add(stat);
										}
								}
							simSummaryStats.add(simSummaryStatsLine);
						}
					// System.out.println(simDatasetsNames);
					
					// Average summary stats computation:				
					ArrayList<Double> averageSummaryStats = new ArrayList<Double>();
					for (int j = 0; j < summaryStats.size(); j++)
						{
							double average = 0;
							for (int k = 0; k < simSummaryStats.size(); k++)
								{
									average = average + simSummaryStats.get(k).get(statsIndexes[j]).doubleValue();
								}
							average = average/simSummaryStats.size();
							Double averageDouble = new Double(average);
							averageSummaryStats.add(averageDouble);
						}
					
					// SD summary stats computation:
					ArrayList<Double> standardDeviationSummaryStats = new ArrayList<Double>();
					for (int j = 0; j < summaryStats.size(); j++)
						{
							double deviationStandard = 0;
							for (int k = 0; k < simSummaryStats.size(); k++)
								{
									double product = 0;
									// System.out.println(statsIndexes[j]);
									product = averageSummaryStats.get(j).doubleValue() - simSummaryStats.get(k).get(statsIndexes[j]).doubleValue();
									product = product*product;
									deviationStandard = deviationStandard + product;
								}
							deviationStandard = deviationStandard/(simSummaryStats.size() - 1);
							deviationStandard = Math.sqrt(deviationStandard);
							Double deviationStandardDouble = new Double(deviationStandard);
							standardDeviationSummaryStats.add(deviationStandardDouble);
						}
					
					// Observed Chi-square computation:
					double obsChiSquare = 0;
					for (int j = 0; j < statsIndexes.length; j++)
						{
							double chiSquare = 0; // System.out.println(averageSummaryStats.get(j) + " - " + obsSummaryStats.get(statsIndexes[j]) + " - " + statsIndexes[j]);
							chiSquare = (averageSummaryStats.get(j)-obsSummaryStats.get(statsIndexes[j]))*(averageSummaryStats.get(j)-obsSummaryStats.get(statsIndexes[j]));
							chiSquare = chiSquare/(standardDeviationSummaryStats.get(j)*standardDeviationSummaryStats.get(j));
							obsChiSquare = obsChiSquare + chiSquare; // System.out.println(chiSquare);
						}

					// Simulated Chi-square's computation:
					ArrayList<Double> simChiSquares = new ArrayList<Double>();
					for (int j = 0; j < simSummaryStats.size(); j++)
						{
							double simChiSquare = 0;
							for (int k = 0; k < statsIndexes.length; k++)
								{
									double chiSquare = 0;
									chiSquare = (averageSummaryStats.get(k)-simSummaryStats.get(j).get(statsIndexes[k]))*(averageSummaryStats.get(k)-simSummaryStats.get(j).get(statsIndexes[k]));
									chiSquare = chiSquare/(standardDeviationSummaryStats.get(k)*standardDeviationSummaryStats.get(k));
									simChiSquare = simChiSquare + chiSquare; // if (j==0) {System.out.println(chiSquare);}
								}
							Double simChiSquareDouble = new Double(simChiSquare);
							simChiSquares.add(simChiSquareDouble);
							// if (j==0) {System.out.println(simChiSquare);}
						}
					
					// P-value computation:
					int chiSquareCounter = 0;
					for (int j = 0; j < simSummaryStats.size(); j++)
						{
							if (simChiSquares.get(j).doubleValue() < obsChiSquare)
								{
									chiSquareCounter = chiSquareCounter + 1;
								}
							else
								{
									// System.out.println(obsChiSquare + " - " + simChiSquares.get(j).doubleValue());
								}
							// System.out.println(chiSquareCounter);
						}
					double size = simSummaryStats.size();
					double pValue = ((simSummaryStats.size()-chiSquareCounter)/size);
					String currentLine = new String();
					currentLine = obsDatasetsNames + " - " + simDatasetsNames + ", p-value = " + (float) pValue;
					externalMessage.add(currentLine);
				}
			else
				{
					ArrayList<Double> pValues = new ArrayList<Double>();
					
					ArrayList<String> lines3 = new ArrayList<String>();
					String name3 = simDatasetsNames + ".txt";
					BufferedReader in3 = new BufferedReader(new FileReader(name3));
					String s3;
					ArrayList<String> lines30 = new ArrayList<String>();
					while((s3 = in3.readLine()) != null) lines30.add(s3);
					lines3 = lines30;
					in3.close();
					ArrayList<ArrayList<Double>> simSummaryStats = new ArrayList<ArrayList<Double>>();
					for (int j = 1; j < lines3.size(); j ++)
						{
							ArrayList<Double> simSummaryStatsLine = new ArrayList<Double>();
							if (lines3.get(j).isEmpty())
								{ }
							else
								{
									String line0 = (String) lines3.get(j);
									String[] line = line0.split("[ 	]+");
									for (int k = 0; k < line.length; k++)
										{
											Double stat = new Double(line[k]);
											simSummaryStatsLine.add(stat);
										}
								}
							simSummaryStats.add(simSummaryStatsLine);
						}
					
					// Average summary stats computation:
					ArrayList<Double> averageSummaryStats = new ArrayList<Double>();
					for (int i = 0; i < summaryStats.size(); i++)
						{
							// System.out.println(statsIndexes[i]);
							double average = 0;
							for (int k = 0; k < simSummaryStats.size(); k++)
								{
									// System.out.println(i + "	" + k);
									// System.out.println(simSummaryStats.get(k).size());
									average = average + simSummaryStats.get(k).get(statsIndexes[i]).doubleValue();
								}
							average = average/simSummaryStats.size();
							// System.out.println(average);
							Double averageDouble = new Double(average);
							averageSummaryStats.add(averageDouble);
						}
					
					// Average summary stats computation:
					ArrayList<Double> standardDeviationSummaryStats = new ArrayList<Double>();
					for (int i = 0; i < summaryStats.size(); i++)
						{
							double deviationStandard = 0;
							for (int k = 0; k < simSummaryStats.size(); k++)
								{
									double product = 0;
									// System.out.println(statsIndexes[j]);
									product = averageSummaryStats.get(i).doubleValue() - simSummaryStats.get(k).get(statsIndexes[i]).doubleValue();
									product = product*product;
									deviationStandard = deviationStandard + product;
								}
							deviationStandard = deviationStandard/(simSummaryStats.size() - 1);
							deviationStandard = Math.sqrt(deviationStandard);
							// System.out.println(deviationStandard);
							Double deviationStandardDouble = new Double(deviationStandard);
							standardDeviationSummaryStats.add(deviationStandardDouble);
						}
					

					// Simulated Chi-square's computation:
					ArrayList<Double> simChiSquares = new ArrayList<Double>();
					for (int i = 0; i < simSummaryStats.size(); i++)
						{
							double simChiSquare = 0;
							for (int k = 0; k < statsIndexes.length; k++)
								{
									double chiSquare = 0;
									chiSquare = (averageSummaryStats.get(k)-simSummaryStats.get(i).get(statsIndexes[k]))*(averageSummaryStats.get(k)-simSummaryStats.get(i).get(statsIndexes[k]));
									chiSquare = chiSquare/(standardDeviationSummaryStats.get(k)*standardDeviationSummaryStats.get(k));
									simChiSquare = simChiSquare + chiSquare;
								}
							Double simChiSquareDouble = new Double(simChiSquare);
							simChiSquares.add(simChiSquareDouble);
						}
					double meanChi = 0; 
					for (int i = 0; i < simChiSquares.size(); i++)
						{
							meanChi = meanChi + simChiSquares.get(i).doubleValue();
						}
					double nberOfChi = simChiSquares.size();
					meanChi = meanChi/nberOfChi;
					
					for (int i = 1; i < lines2.size(); i++)
						{
							String line22a = (String) lines2.get(i);
							obsSummaryStats = new ArrayList<Double>();
							String[] line22b = line22a.split("[ 	]+");
							for (int j = 0; j < line22b.length; j++)
								{
									Double stat = new Double(line22b[j]);
									obsSummaryStats.add(stat);
								}
							
							// Observed Chi-square computation:
							double obsChiSquare = 0;
							for (int j = 0; j < statsIndexes.length; j++)
								{
									double chiSquare = 0;
									chiSquare = (averageSummaryStats.get(j)-obsSummaryStats.get(statsIndexes[j]))*(averageSummaryStats.get(j)-obsSummaryStats.get(statsIndexes[j]));
									chiSquare = chiSquare/(standardDeviationSummaryStats.get(j)*standardDeviationSummaryStats.get(j));
									obsChiSquare = obsChiSquare + chiSquare;
								}
							
							// P-value computation:
							int chiSquareCounter = 0;
							for (int j = 0; j < simSummaryStats.size(); j++)
								{
									// System.out.println(obsChiSquare + " - " + simChiSquares.get(j).doubleValue());
									if (simChiSquares.get(j).doubleValue() < obsChiSquare)
										{
											chiSquareCounter = chiSquareCounter + 1;
										}
									// System.out.println(chiSquareCounter);
								}
							double size = simSummaryStats.size();
							double pValue = ((simSummaryStats.size()-chiSquareCounter)/size);
							Double doublePValue = new Double(pValue);
							pValues.add(doublePValue);
						}
					
					double meanPValue = 0; 
					for (int i = 0; i < pValues.size(); i++)
						{
							meanPValue = meanPValue + pValues.get(i).doubleValue();
						}
					double nberOfPValues = pValues.size();
					meanPValue = meanPValue/nberOfPValues;			
					double stdvPValue = 0;
					int numberOfPvaluesHigherThanFivePercents = 0;
					// System.out.println("		" + obsDatasetsNames + "-" + simDatasetsNames);
					// ArrayList<String> bufferString = new ArrayList<String>(); 
					// bufferString.add(obsDatasetsNames + "-" + simDatasetsNames);
					for (int i = 0; i < pValues.size(); i++)
						{
							double product = 0;
							product = meanPValue - pValues.get(i).doubleValue();
							product = product*product;
							stdvPValue = stdvPValue + product;
							// System.out.println(pValues.get(i).doubleValue());
							// String pValueString = new String(); 
							// pValueString = Double.toString(pValues.get(i).doubleValue());
							// bufferString.add(pValueString);
							if (pValues.get(i).doubleValue() > 0.05)
								{
									numberOfPvaluesHigherThanFivePercents = numberOfPvaluesHigherThanFivePercents + 1;
								}
						}
					stdvPValue = stdvPValue/(nberOfPValues - 1);
					stdvPValue = Math.sqrt(stdvPValue);
					int counterPval = 0; counterPval = numberOfPvaluesHigherThanFivePercents;
					String currentLine = new String();
					currentLine = obsDatasetsNames + " - " + simDatasetsNames + " (mean Chi-square = " + (float) meanChi + "), mean p-value (SD,#>0.05) = " + (float) meanPValue + " (" + (float) stdvPValue + "," + counterPval + ")";
					// currentLine = obsDatasetsNames + "	" + simDatasetsNames + "	" + (float) meanChi + "	" + (float) meanPValue + "	" + (float) stdvPValue;
					externalMessage.add(currentLine);
					// externalMessage.addAll(bufferString);
				}
		}
}
