package spads1;

// Class created by Simon Dellicour (June 2011)

import java.util.ArrayList;

public class Locus 
{
	public int ID;
	public double length;
	public double ploidy;
	public ArrayList<Node> nodes;
	public ArrayList<Population> populations;
	public ArrayList<Group> userGroups;
	public int[][] delaunayTriangulation;
	public int[][] nodesMismatches;
	public int[][] permutHaplotypesNodesMismatches;
	public double[][] monmonierDistances;
	public double[][] pairwiseFstPop;
	public double[][] pairwiseFstPopNumerator;
	public double[][] pairwiseFstPopDenominator;
	public double[][] pairwiseFstGroup;
	public double[][] pairwiseFstGroupNumerator;
	public double[][] pairwiseFstGroupDenominator;
	public ArrayList<Node> haplotypes;
	public int[][] haplotypesMismatches;
	public int[][] permutHaplotypesMismatches;
	public ArrayList<Node> haplotypesInPopsWithMoreThanOneGeneCopy;
	public double polymorphicSites;
	public double Gst;
	public double Nst;
	public double NstGst;
	public double Fst;
	public double amovaFsc;
	public double amovaFst;
	public double amovaFct;
	public double pValueGst;
	public double pValueNst;
	public double pValueNstGst;
	public double pValueFst;
	public double pValueamovaFsc;
	public double pValueamovaFst;
	public double pValueamovaFct;
	
	public Locus(int id)
		{
			ID = id;
			ploidy = -1;
			populations = new ArrayList<Population>();
			userGroups = new ArrayList<Group>();
		}
}