package spads1;

// Class created by Simon Dellicour (June 2011)

import java.util.ArrayList;

public class Population 
{
	public String popName;
	public int popID;
	public int popDistanceIndex;
	public ArrayList<Node> nodes;
	public ArrayList<Individual> individuals;
	public ArrayList<Individual> individualsGhosts;
		/* modified Individual ArrayList with "ghosts" nodes created when the
		   ploidy of a locus is lower than the maximum observed ploidy. */
	public double[] position;
	public int samovaGroupID;
	public int barrierGroupID;
	
	public Population(String name, int id)
		{
			popName = name;
			popID = id;
			nodes = new ArrayList<Node>();
			individuals = new ArrayList<Individual>();
			individualsGhosts = new ArrayList<Individual>();
			position = new double[2];
			barrierGroupID = -1;
		}
}
