package spads1;

// Class created by Simon Dellicour (June 2011)

import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.LineBorder;
import javax.swing.JTextArea;

public class Progression extends JFrame
{
	private static final long serialVersionUID = 1L;
	public JPanel panel;
	public JTextArea textArea;
	public MessageConsole mc;

	public Progression()
		{
			getContentPane().setBackground(Color.WHITE);
			setTitle("Analysis progression");
			setSize(320, 205);
			panel = new JPanel();
			panel.setBorder(new LineBorder(Color.LIGHT_GRAY, 3));
			panel.setLayout(null);
			panel.setBackground(Color.WHITE);
			getContentPane().add(panel, BorderLayout.CENTER);
			textArea = new JTextArea();
			textArea.setBounds(6, 6, 308, 171);
			panel.add(textArea);
			mc = new MessageConsole(textArea, false);
			mc.redirectOut();
			mc.redirectErr(Color.RED, null);
			mc.setMessageLines(100);		
			mc.redirectOut(null, System.out);
		}
}
